--------------------------------------------------
--   N A M E S P A C E    D E F I N I T I O N   --
--------------------------------------------------
EBRA_TombOfSargeras_Plugin = {};


--------------------------------------------------
-- P R I V A T E / L O C A L  V A R I A B L E S --
--------------------------------------------------


--------------------------------------------------
-- P R I V A T E / L O C A L  F U N C T I O N S --
--------------------------------------------------

local function tauntOnStackCount(id, count)
  -- Check whether the Player is tanking
  local pIsTarget = EBRA.isTarget("player", "targettarget");
  local fIsTarget = EBRA.isTarget("focus", "targettarget");
  
  -- We only need to check whether the current Player needs to taunt if he is currently not tanking.
  if pIsTarget == false and fIsTarget == true then
    -- p: Player, f: Focus (Other Tank)
    -- Get Tank Debuffs
    local pDebuff = EBRA.getDebuffStack("player", id);
    local fDebuff = EBRA.getDebuffStack("focus", id);
    
    -- If the Target has 'count' Stacks of the Debuff, then taunt.
    if pDebuff <= 0 and fDebuff >= count then
      EBRA.playSound("interface\\addons\\EbonBladeRaidAssist\\Resources\\taunt.mp3", 1);
    end
  end
end


local function tauntWithoutDebuff(id)
  -- Check whether the Player is tanking
  local pIsTarget = EBRA.isTarget("player", "targettarget");
  local fIsTarget = EBRA.isTarget("focus", "targettarget");
  
  -- We only need to check whether the current Player needs to taunt if he is currently not tanking.
  if pIsTarget == false and fIsTarget == true then
    -- p: Player, f: Focus (Other Tank)
    -- Get Tank Debuffs
    local pDebuff = EBRA.getRemainingDebuffTime("player", id);
    local fDebuff = EBRA.getRemainingDebuffTime("focus" , id);
    
    
    -- If the remaining Debuff Time of the Player is less the remaining Debuff Time of the other Tank, the Player needs to taunt
    if pDebuff <= 0 and fDebuff > 0 then
      EBRA.playSound("interface\\addons\\EbonBladeRaidAssist\\Resources\\taunt.mp3", 1);
    end
  end
end


--------------------------------------------------
-- P U B L I C / G L O B A L  F U N C T I O N S --
--------------------------------------------------


-- Plays a Sound everytime the Player needs to do something.
function EBRA_TombOfSargeras_Plugin.handle()
  if EBRA.isTank("player") == true then
    tauntOnStackCount(231363, 1); -- Goroth: Burning Armor
    tauntOnStackCount(231998, 5); -- Harjatan: Jagged Abrasion
    tauntOnStackCount(236550, 1); -- Sisters of the Moon: Discorporate
    tauntOnStackCount(239264, 2); -- Sisters of the Moon: Lunar Fire
    tauntOnStackCount(230214, 1); -- Mistress Sassz'ine: Burden of Pain
    tauntOnStackCount(243276, 1); -- Maiden of Vigilance: Unstable Soul
    tauntOnStackCount(236494, 2); -- Fallen Avatar: Desolate
  end
end


--------------------------------------------------
--        E N D       O F     F I L E           --
--------------------------------------------------
return EBRA_TombOfSargeras_Plugin;